-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassImageset.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassImageset where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Construct a new Imageset - Details: Under certain renderers it may be required that the source image dimensions be some power of 2, if this condition is not met then stretching and other undesired side-effects may be experienced. To be safe from such effects it is generally recommended that all images that you load have dimensions that are some power of 2.
new :: String  -- ^ name - String object holding the name to be assigned to the created imageset.
  ->  String  -- ^ filename - String object holding the filename of the image that is to be loaded. The image should be of some format that is supported by the Renderer that is in use.
  ->  String  -- ^ resourceGroup - Resource group identifier to be passed to the resource manager, which may specify a group from which the image file is to be loaded.
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 a3 =
  withCString a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  alloca $ \a4' -> 
  new'_ a1' a2' a3' a4' >>= \res ->
  peek  a4'>>= \a4'' -> 
  return (a4'')
{-# LINE 50 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Destroys Imageset
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 54 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return String object holding the name of the Imageset
getName :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (String)
 -- ^ return value - String object that holds the name of the     
getName a1 =
  withHG3DClass a1 $ \a1' -> 
  alloc64k $ \a2' -> 
  getName'_ a1' a2' >>= \res ->
  peekCString  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 59 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return number of images defined for this Imageset
getImageCount :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Int)
 -- ^ return value - uint value equal to the number of Image objects defined for the     
getImageCount a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getImageCount'_ a1' a2' >>= \res ->
  peekIntConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 64 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return true if an Image with the specified name exists. 
isImageDefined :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image to look for.
  ->  IO (Bool)
 -- ^ return value - true if an Image object named     
isImageDefined a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  isImageDefined'_ a1' a2' a3' >>= \res ->
  peekBoolUtil  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 70 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | remove the definition for the Image with the specified name. If no such Image exists, nothing happens. 
undefineImage :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image object to be removed from the Imageset, 
  ->  IO ()
 -- ^ return value - Nothing.     
undefineImage a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  undefineImage'_ a1' a2' >>= \res ->
  return ()
{-# LINE 75 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Removes the definitions for all Image objects currently defined in the Imageset
undefineAllImages :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing     
undefineAllImages a1 =
  withHG3DClass a1 $ \a1' -> 
  undefineAllImages'_ a1' >>= \res ->
  return ()
{-# LINE 79 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return the width of the named image. 
getImageWidth :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image.
  ->  IO (Float)
 -- ^ return value - float value equalling the width of the requested Image.    
getImageWidth a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  getImageWidth'_ a1' a2' a3' >>= \res ->
  peekFloatConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 85 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return the height of the named image. 
getImageHeight :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image.
  ->  IO (Float)
 -- ^ return value - float value equalling the height of the requested Image.    
getImageHeight a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  getImageHeight'_ a1' a2' a3' >>= \res ->
  peekFloatConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 91 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return the x rendering offset for the named image. 
getImageOffsetX :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image.
  ->  IO (Float)
 -- ^ return value - float value equal to the x rendering offset applied when drawing the requested Image.    
getImageOffsetX a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  getImageOffsetX'_ a1' a2' a3' >>= \res ->
  peekFloatConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 97 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | return the y rendering offset for the named image. 
getImageOffsetY :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ name - String object holding the name of the Image.
  ->  IO (Float)
 -- ^ return value - float value equal to the y rendering offset applied when drawing the requested Image.    
getImageOffsetY a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  getImageOffsetY'_ a1' a2' a3' >>= \res ->
  peekFloatConv  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 103 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Return whether this Imageset
isAutoScaled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if     
isAutoScaled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isAutoScaled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 108 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Enable or disable auto-scaling for this Imageset
setAutoScalingEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - true to enable auto-scaling, false to disable auto-scaling.
  ->  IO ()
 -- ^ return value - Nothing.     
setAutoScalingEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setAutoScalingEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 113 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Sets the default resource group to be used when loading imageset data. 
setDefaultResourceGroup :: String  -- ^ resourceGroup - String describing the default resource group identifier to be used.
  ->  IO ()
 -- ^ return value - Nothing.     
setDefaultResourceGroup a1 =
  withCString a1 $ \a1' -> 
  setDefaultResourceGroup'_ a1' >>= \res ->
  return ()
{-# LINE 117 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}

-- | Returns the default resource group currently set for Imagesets. 
getDefaultResourceGroup :: IO (String)
 -- ^ return value - String describing the default resource group identifier that will be used when loading     
getDefaultResourceGroup =
  alloc64k $ \a1' -> 
  getDefaultResourceGroup'_ a1' >>= \res ->
  peekCString  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 121 ".\\HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_construct"
  new'_ :: ((Ptr CChar) -> ((Ptr CChar) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ())))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getName"
  getName'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getImageCount"
  getImageCount'_ :: ((HG3DClassPtr) -> ((Ptr CUInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_isImageDefined"
  isImageDefined'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CInt) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_undefineImage"
  undefineImage'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_undefineAllImages"
  undefineAllImages'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getImageWidth"
  getImageWidth'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CFloat) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getImageHeight"
  getImageHeight'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CFloat) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getImageOffsetX"
  getImageOffsetX'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CFloat) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getImageOffsetY"
  getImageOffsetY'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CFloat) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_isAutoScaled"
  isAutoScaled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_setAutoScalingEnabled"
  setAutoScalingEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_setDefaultResourceGroup"
  setDefaultResourceGroup'_ :: ((Ptr CChar) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassImageset.chs.h cegui_imgst_getDefaultResourceGroup"
  getDefaultResourceGroup'_ :: ((Ptr CChar) -> (IO ()))
